searchData={"items":[{"type":"task","title":"mix devenv.new","doc":"Creates a new project using any Mix project generator, then sets up development environment.","ref":"Mix.Tasks.Devenv.New.html"},{"type":"task","title":"Options - mix devenv.new","doc":"All options are passed through to the specified task, except for the following:\n\n* `--devenv` - A comma-separated list of feature selectors","ref":"Mix.Tasks.Devenv.New.html#module-options"},{"type":"task","title":"Selectors - mix devenv.new","doc":"Valid feature selectors:\n\n  Languages:\n    * bun - Install Bun runtime/package manager\n    * elixir - Elixir version to use\n    * npm - Node.js runtime with npm\n\n  Services:\n    * minio - MinIO object storage (S3-compatible)\n    * postgres - PostgreSQL database\n    * redis - Redis cache/session store\n\nFeatures can include version specifiers, e.g., elixir=1.17","ref":"Mix.Tasks.Devenv.New.html#module-selectors"},{"type":"task","title":"Examples - mix devenv.new","doc":"# Create a Phoenix project with devenv\n    mix devenv.new phx.new my_app --devenv postgres,redis\n\n    # Create an Igniter project with devenv\n    mix devenv.new igniter.new my_project --devenv elixir=1.17,postgres --install ash,ash_postgres\n\n    # Create a basic Elixir project with devenv\n    mix devenv.new new my_lib --devenv elixir=1.17,minio --sup\n\nThis will:\n1. Create a new project using the specified generator\n2. Initialise devenv in the project\n3. Configure devenv.nix with requested features","ref":"Mix.Tasks.Devenv.New.html#module-examples"},{"type":"extras","title":"devenv.new","doc":"# devenv.new\n\nA Mix task that wraps any Elixir Mix project generator in a [devenv.sh](https://devenv.sh) environment.","ref":"readme.html"},{"type":"extras","title":"Installation - devenv.new","doc":"Install the archive [directly from Hex](https://hex.pm/packages/devenv_new):\n\n```bash\nmix archive.install hex devenv_new\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - devenv.new","doc":"Use `mix devenv.new` to wrap any Mix project generator:\n\n```bash\n# Create a Phoenix project with devenv\nmix devenv.new phx.new my_app --devenv postgres,redis\n\n# Create an Igniter project with devenv\nmix devenv.new igniter.new my_project --devenv elixir=1.17,postgres --install ash,ash_postgres\n\n# Create a basic Elixir project with devenv\nmix devenv.new new my_lib --devenv elixir=1.17,minio --sup\n\n# To run Mix in a temporary Elixir Nix environment\nnix-shell -p elixir --run 'mix devenv.new igniter.new demo_app '\\\n'--devenv postgres,bun '\\\n'--install ash,ash_postgres,ash_authentication_phoenix,ash_graphql '\\\n'--auth-strategy magic_link '\\\n'--with phx.new'\n\ncd demo_app\ndevenv up\nMIX_ENV=test mix ash.reset\nmix test\n```\n\nSee [story.html](https://hexdocs.pm/devenv_new/assets/story.html) ([local](assets/story.html)) for a full log of a generator run.","ref":"readme.html#usage"},{"type":"extras","title":"Devenv Features - devenv.new","doc":"Available devenv features:\n\n* **elixir** - Elixir runtime (supports version specification, e.g., `elixir=1.17`)\n* **postgres** - PostgreSQL database with project-specific databases\n* **redis** - Redis cache/session store\n* **minio** - MinIO object storage (S3-compatible)\n* **npm** - Node.js runtime with npm\n* **bun** - Bun runtime/package manager\n\nThe generator is built to be [easily extendable](https://github.com/serpent213/devenv_new/tree/master/priv),\nby creating an `.eex` template file and adding it to the look-up table in `devenv.new.ex`.","ref":"readme.html#devenv-features"},{"type":"extras","title":"Examples - devenv.new","doc":"","ref":"readme.html#examples"},{"type":"extras","title":"Phoenix with PostgreSQL and Redis - devenv.new","doc":"```bash\nmix devenv.new phx.new my_phoenix_app --devenv postgres,redis\ncd my_phoenix_app\ndevenv shell  # or use direnv\n```","ref":"readme.html#phoenix-with-postgresql-and-redis"},{"type":"extras","title":"Igniter with Ash and PostgreSQL - devenv.new","doc":"```bash\nmix devenv.new igniter.new my_ash_app --devenv elixir=1.17,postgres --install ash,ash_postgres\n```","ref":"readme.html#igniter-with-ash-and-postgresql"},{"type":"extras","title":"Basic Elixir Library with MinIO - devenv.new","doc":"```bash\nmix devenv.new new my_lib --devenv elixir=1.17,minio --sup\n```","ref":"readme.html#basic-elixir-library-with-minio"},{"type":"extras","title":"How it Works - devenv.new","doc":"1. Runs the specified Mix task (e.g., `phx.new`, `igniter.new`, `new`)\n2. Initializes devenv in the created project directory\n3. Generates `devenv.nix` with requested features\n4. Creates project-specific database configurations when applicable","ref":"readme.html#how-it-works"},{"type":"extras","title":"Developer Instructions - devenv.new","doc":"","ref":"readme.html#developer-instructions"},{"type":"extras","title":"Installing Archive Locally - devenv.new","doc":"For development, install the archive from your local checkout:\n\n```bash\n# Clone and build the archive\ngit clone https://github.com/your-username/devenv_new.git\ncd devenv_new\nmix archive.build\nmix archive.install devenv_new-*.ez --force\n\n# Test the installation\nmix devenv.new --help\n```","ref":"readme.html#installing-archive-locally"},{"type":"extras","title":"Rebuilding After Changes - devenv.new","doc":"```bash\n# Rebuild and reinstall\nmix archive.build\nmix archive.install devenv_new-*.ez --force\n```","ref":"readme.html#rebuilding-after-changes"},{"type":"extras","title":"Uninstalling - devenv.new","doc":"```bash\nmix archive.uninstall devenv_new\n```","ref":"readme.html#uninstalling"},{"type":"extras","title":"Requirements - devenv.new","doc":"- Elixir/Mix installed\n- [devenv.sh](https://devenv.sh/getting-started/) installed\n- The target project generator (e.g., `phx.new`, `igniter.new`) available","ref":"readme.html#requirements"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}